//----------------------------------------------------------------------//
// VvXN[o[Epl										//
//																		//
//  TListBoxATStringGridATScrollBar ̉ꂩɊ֘At\			//
//----------------------------------------------------------------------//
#ifndef UsrScrollPanelH
#define UsrScrollPanelH

//---------------------------------------------------------------------------
#include <Vcl.CheckLst.hpp>
#include <Vcl.Grids.hpp>
#include "usr_scale.h"

//---------------------------------------------------------------------------
//Flag
#define USCRPNL_FLAG_FL		0x0001	//t@CXg
#define USCRPNL_FLAG_GL		0x0002	//ꗗXg
#define USCRPNL_FLAG_TV		0x0004	//eLXgrA[

#define USCRPNL_FLAG_P_WP	0x0020	//epl WindowProc ւ
#define USCRPNL_FLAG_L_WP	0x0040	//Xg{bNX WindowProc ւ
#define USCRPNL_FLAG_G_WP	0x0080	//Obh WindowProc ւ
#define USCRPNL_FLAG_HS		0x0100	//XN[o[t(ListBox or Grid)

//---------------------------------------------------------------------------
#define USCRPNL_SCRTYPE_V	0		//XN[o[
#define USCRPNL_SCRTYPE_H	1		//XN[o[

//---------------------------------------------------------------------------
#define WM_NYANFI_USCROLL	(WM_APP + 500)	//t@CXg̃mup
#define WM_NYANFI_UPDKNOB	(WM_APP + 501)	//t@CXg̃muXVp

//---------------------------------------------------------------------------
class UsrScrollPanel
{
private:
	TPanel     *ScrPanelV;			//XN[pl
	TPaintBox  *ScrPaintBoxV;		//`̈

	TPanel     *ScrPanelH;			//XN[pl
	TPaintBox  *ScrPaintBoxH;		//`̈

	TRect ScrKnobRectV;				//mu̒`
	TRect ScrKnobRectH;
	int   ScrKnobMaxY;				//őmuʒu
	int   ScrKnobMaxX;

	bool  ScrCatchKnob;				//muł
	int   ScrCatchYp;
	int   ScrCatchXp;
	int   ScrPage;

	int   UsKnobWidth;				//XP[O100%̃mu
	int   LastPPI;

	TWndMethod org_ParentPanelWndProc;
	void __fastcall ParentPanelWndProc(TMessage &msg)
	{
		if (msg.Msg==WM_ERASEBKGND) { msg.Result = 1; return; }
		org_ParentPanelWndProc(msg);
		if (msg.Msg==WM_SIZE) UpdateKnob();
	}

	TWndMethod org_AssoListWndProc;
	void __fastcall AssoListWndProc(TMessage &msg)
	{
		if (msg.Msg==WM_PAINT && !ScrCatchKnob) Repaint();
		org_AssoListWndProc(msg);
	}

	TWndMethod org_AssoChkListWndProc;
	void __fastcall AssoChkListWndProc(TMessage &msg)
	{
		if (msg.Msg==WM_PAINT && !ScrCatchKnob) Repaint();
		org_AssoChkListWndProc(msg);
	}

	TWndMethod org_AssoGridWndProc;
	void __fastcall AssoGridWndProc(TMessage &msg)
	{
		if (msg.Msg==WM_PAINT && !ScrCatchKnob) Repaint();
		org_AssoGridWndProc(msg);
	}

	TWndMethod org_ScrPanelVWndProc;
	void __fastcall ScrPanelVWndProc(TMessage &msg)
	{
		if (msg.Msg==WM_ERASEBKGND) { msg.Result = 1; return; }
		org_ScrPanelVWndProc(msg);
		if (org_ParentPanelWndProc==NULL && msg.Msg==WM_SIZE) UpdateKnob();
	}

	TWndMethod org_ScrPanelHWndProc;
	void __fastcall ScrPanelHWndProc(TMessage &msg)
	{
		if (msg.Msg==WM_ERASEBKGND) { msg.Result = 1; return; }
		org_ScrPanelHWndProc(msg);
		if (org_ParentPanelWndProc==NULL && msg.Msg==WM_SIZE) UpdateKnob();
	}

	void __fastcall ScrPaintBoxPaint(TObject *Sender);
	int  __fastcall GetKnobPosH();

	int  __fastcall get_GridTotalWidth();
	void __fastcall set_GridLefCol(int pos);
	int  __fastcall get_GridTotalHeight();
	void __fastcall set_GridTopRow(int pos);

	void __fastcall ScrPaintBoxMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall ScrPaintBoxMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall ScrPaintBoxMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);

public:
	TPanel			*ParentPanel;		//epl
	TListBox		*AssoListBox;		//֘AXg{bNX
	TCheckListBox	*AssoChkListBox;	//֘A`FbNXg{bNX
	TStringGrid		*AssoStrGrid;		//֘AObh
	TScrollBar		*AssoScrollBar;		//֘AXN[o[

	int Flag;							//ݒtO

	int FKnobWidth;						//mu
	void __fastcall SetKnobWidth(int Value)
	{
		FKnobWidth  = Value;
		UsKnobWidth = UnscaledInt(Value, ParentPanel);
		LastPPI     = ParentPanel->CurrentPPI;
	}
	__property int KnobWidth = {read = FKnobWidth,  write = SetKnobWidth};

	Graphics::TBitmap *KnobImgBuffV;	//mu摜
	Graphics::TBitmap *KnobImgBuffH;	//mu摜

	TColor Color;						//wiF
	TColor KnobColor;					//muF
	TColor KnobBdrColor;				//mu֊sF
	TColor KnobActColor;				//hbÕmuF
	TColor HitLineColor;				//qbgʒuF
	TColor SelLineColor;				//IʒuF
	int    PosLineAlpha;				//ʒu\At@

	bool ListCsrVisible;				//Xg{bNX̃J[\ɉ̈

	TMouseEvent OnRButtonUp;			//ENbNCxg

	bool FVisible;
	void __fastcall SetVisible(bool Value)
	{
		FVisible = Value;
		if (!FVisible) {
			ScrPanelV->Visible = VisibleV = false;
			if (ScrPanelH) ScrPanelH->Visible = VisibleH = false;
		}
	}
	__property bool Visible = {read = FVisible,  write = SetVisible};

	bool VisibleV, VisibleH;			//XN[o[̕\

	TStringList *HitLines;				//ʈʒuXg
	TStringList *SelLines;				//IڈʒuXg

	UsrScrollPanel(TPanel *pp, TListBox *lp,      int flag);
	UsrScrollPanel(TPanel *pp, TCheckListBox *lp, int flag);
	UsrScrollPanel(TPanel *pp, TStringGrid *gp,   int flag);
	UsrScrollPanel(TPanel *pp, TScrollBar *sp,    int flag);
	~UsrScrollPanel();

	void __fastcall InitializePanel();
	void __fastcall UpdateKnob();
	void __fastcall Repaint();

	void __fastcall SetRBCornerPanel(TPanel *pp);

	bool __fastcall KeyWordChanged(UnicodeString kwd, int max_cnt, bool case_sw = false, int code_page = 0);
	void __fastcall AddHitLine(int n);
};
//---------------------------------------------------------------------------
#endif
